Cambrian Token Transaction Feed (Time Bounded) API

By Cambrian Network solana

GET /api/v1/solana/token-transactions-time-bounded

Token Transaction Feed (Time Bounded)

Overview

Get detailed transaction data for any SPL token with precise Unix timestamp filtering for historical analysis and event-driven research. This endpoint returns individual buy/sell transactions across major Solana DEXs within a specified time window, including trade size, USD value, and pool/DEX details.

Business Value

  • Historical Analysis: Enables precise time-bounded queries for tracking token activity during specific events or periods
  • Event-Driven Research: Perfect for analyzing token behavior around announcements, launches, or market events
  • Transaction Tracking: Comprehensive view of all buy/sell transactions with DEX information and pricing data
  • Real-time Monitoring: Track recent transaction activity with slot-level precision for up-to-the-minute insights
  • Multi-DEX Coverage: Aggregates transaction data across major Solana DEXs including Meteora, Raydium CLMM, and others

Endpoint Details

URL:

https://api.cambrian.org/solana/token-transactions-time-bounded

Method: GET
Authentication: Required via X-API-Key header

Query Parameters

Parameter Type Required Default Description
token_address string Yes - Token program address (base58-44 string). See tokens for valid addresses.
after_time integer Yes - Unix timestamp - start time for data range
before_time integer Yes - Unix timestamp - end time for data range
limit integer No 100 Limit the number of results.
offset integer No 0 Offset the results, allows you to skip a number of rows before starting to return rows.

Response Field Descriptions

Response Field Type Description
signature String Transaction signature (unique identifier) for the trade
slot UInt64 Solana slot number in which the transaction was processed
txType String Transaction type, e.g. buy or sell
tokenAmount Float64 Amount of the token traded in the transaction
valueUSD Float64 USD value of the traded amount at execution time
priceUSD Float64 USD price per token at the time of the transaction
dex String DEX on which the transaction occurred (e.g. Meteora, Raydium CLMM)
poolAddress String Address of the liquidity pool where the transaction occurred

Examples

1. Fetch Transactions Within a Fixed Time Window

Retrieve transaction data for SOL within a specific Unix timestamp range, limited to 10 results.

curl -X GET "https://api.cambrian.org/solana/token-transactions-time-bounded?token_address=So11111111111111111111111111111111111111112&after_time=1735689600&before_time=1735776000&limit=10" \
  -H "X-API-Key: YOUR_API_KEY" \
  -H "Content-Type: application/json"

Response:

[
  {
    "columns": [
      {
        "name": "signature",
        "type": "String"
      },
      {
        "name": "slot",
        "type": "UInt64"
      },
      {
        "name": "txType",
        "type": "String"
      },
      {
        "name": "tokenAmount",
        "type": "Float64"
      },
      {
        "name": "valueUSD",
        "type": "Float64"
      },
      {
        "name": "priceUSD",
        "type": "Float64"
      },
      {
        "name": "dex",
        "type": "String"
      },
      {
        "name": "poolAddress",
        "type": "String"
      }
    ],
    "data": [
      [
        "4Dqa1fme5FfHC1iBJ9jUPVbRsDJ92SmSAyFP138R5ybUiX38UC9XVxB9ZKjmj7nXoo27PCc5Ew76SedE1e33cfVz",
        311292616,
        "buy",
        0.074712157,
        14.489356306005309,
        193.9357246238428,
        "Meteora",
        "FqW6QxWG7kDHbQgZ9pxZR5rqXYJHd7ZHwUEcCugHFmSQ"
      ],
      [
        "5NY1QG3qHqr333JHWgxnPVJsqgKdyHtcvybQLkpBmhft8jXtprBgXgR3KM1fbniBGcnanV1vdyzTQnDEDYMzohBW",
        311292616,
        "buy",
        5.540280975,
        1074.4584055063153,
        193.9357246238428,
        "Meteora",
        "FqW6QxWG7kDHbQgZ9pxZR5rqXYJHd7ZHwUEcCugHFmSQ"
      ],
      [
        "2BjnScg6rTGu3757nbPkqyM3gdr18CQHwC13foo4bTdKdqCNTrCvvNPRsqf8GYj4it45CZu3qEWzkJyUNFBHUxHq",
        311292616,
        "sell",
        11.344764636,
        2200.1551503696064,
        193.9357246238428,
        "Raydium CLMM",
        "EtU7GUW6ogxke9gSjRFm8akgxwyuMT4Rm1mgbkEBTi34"
      ],
      [
        "2BjnScg6rTGu3757nbPkqyM3gdr18CQHwC13foo4bTdKdqCNTrCvvNPRsqf8GYj4it45CZu3qEWzkJyUNFBHUxHq",
        311292616,
        "sell",
        11.344764636,
        2200.1551503696064,
        193.9357246238428,
        "Raydium CLMM",
        "EtU7GUW6ogxke9gSjRFm8akgxwyuMT4Rm1mgbkEBTi34"
      ],
      [
        "58vRkVdv26UFFfsyH8x6SzrrsZvHnisLppetJFqGA8hirJsKxzN6JiXLmZkH41r9Q41cpmkBszLj9VJeVxgF7HDZ",
        311292616,
        "sell",
        11.319778006,
        2195.309350174648,
        193.9357246238428,
        "Raydium CLMM",
        "8sN9549P3Zn6xpQRqpApN57xzkCh6sJxLwuEjcG2W4Ji"
      ],
      [
        "58vRkVdv26UFFfsyH8x6SzrrsZvHnisLppetJFqGA8hirJsKxzN6JiXLmZkH41r9Q41cpmkBszLj9VJeVxgF7HDZ",
        311292616,
        "sell",
        11.319778006,
        2195.309350174648,
        193.9357246238428,
        "Raydium CLMM",
        "8sN9549P3Zn6xpQRqpApN57xzkCh6sJxLwuEjcG2W4Ji"
      ],
      [
        "uakqqgxhd3P6YFwCoydaPYwmisBuze263ZUhrMQmhrpTyTbLxtkGCSf6pDn5R6aAa8bnEGxVFKfpfWvh8o1H89v",
        311292615,
        "buy",
        6.3539e-05,
        0.012322482006874347,
        193.9357246238428,
        "Meteora",
        "BAn32AF4BZ9npV6ufFKq9JR85SiokJg9VDmHH1v1ZC6f"
      ],
      [
        "4bhbmYadFwcDm2KX9JuS33ZWUNF7UZqYmsngeb8JKji7vsD5uCExNaMSo48c55x5XzVbL84YY9z68JPaXPTQTLzy",
        311292615,
        "sell",
        0.117894634,
        22.863981274052733,
        193.9357246238428,
        "Meteora",
        "7yhzz79wnrtxZ27RrsqxtHUFH69tWeQs8U4ptUdNGtyU"
      ],
      [
        "5Sv2ZpredmSBDyYgRuz43CbJgU3T9bKrg2ACJvc56ekg9qv9TqLnxSYpsayuxp4nZ5fpCwffVZZjFtVRJxfbaAeP",
        311292615,
        "sell",
        0.167196515,
        32.4253772911062,
        193.9357246238428,
        "Meteora",
        "CZWD8zbzFwdjv13FJcCgHg2Ytyam9H2NsXVLZMeyYFCy"
      ],
      [
        "z4wKCXk1roenee5UgMMr6GSeiJZ9a7T9dMdQEZDi7Q1ayGLPuzUzoEkPeDRLTxLgBKeUqaBdAmLWh14RKMmv15X",
        311292615,
        "sell",
        0.00067343,
        0.13060213503343446,
        193.9357246238428,
        "Meteora",
        "BTz3nMDswq6mTBMPFzkxacRR7gqo2VR7qsR2t9cR8eR6"
      ]
    ],
    "rows": 10
  }
]

Note: result collections are limited to 10 items per request via the limit parameter (maximum 1000).

This response shows 10 SOL transactions between the specified timestamps, mixing buy and sell activity across Meteora and Raydium CLMM pools, each with its own token amount, USD value, and price.

x402 Payment Option

This endpoint supports pay-per-use access via the x402 payment protocol (v2), paying $0.05 USDC per request through blockchain micropayments. No API key required.

Quick Start (TypeScript)

npm install @x402/fetch @x402/evm viem
import { x402Client } from "@x402/core/client";
import { ExactEvmScheme } from "@x402/evm/exact/client";
import { wrapFetchWithPayment } from "@x402/fetch";
import { privateKeyToAccount } from "viem/accounts";

const signer = privateKeyToAccount(process.env.EVM_PRIVATE_KEY as `0x${string}`);
const client = new x402Client();
client.register("eip155:*", new ExactEvmScheme(signer));

const fetchWithPayment = wrapFetchWithPayment(fetch, client);
const response = await fetchWithPayment(
  "https://x402.cambrian.org/solana/token-transactions-time-bounded"
);
const data = await response.json();

Quick Start (Python)

pip install "x402[httpx]"
import asyncio, os
from eth_account import Account
from x402 import x402Client
from x402.http.clients import x402HttpxClient
from x402.mechanisms.evm import EthAccountSigner
from x402.mechanisms.evm.exact.register import register_exact_evm_client

async def main():
    client = x402Client()
    account = Account.from_key(os.getenv("EVM_PRIVATE_KEY"))
    register_exact_evm_client(client, EthAccountSigner(account))

    async with x402HttpxClient(client) as http:
        response = await http.get("https://x402.cambrian.org/solana/token-transactions-time-bounded")
        print(response.json())

asyncio.run(main())

Payment Flow

  1. Send a normal request to the endpoint (no API key needed)
  2. Server returns 402 Payment Required with payment details
  3. The x402 SDK automatically signs a payment authorization with your wallet
  4. The SDK resubmits the request with the signed payment
  5. Server verifies payment and returns the API response

The x402 SDK handles steps 2 through 5 automatically.

Network: Base (chain ID 8453) | Currency: USDC | Price: $0.05 per request